/* libguestfs generated file
 * WARNING: THIS FILE IS GENERATED BY 'src/generator.ml'.
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2009 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <caml/config.h>
#include <caml/alloc.h>
#include <caml/callback.h>
#include <caml/fail.h>
#include <caml/memory.h>
#include <caml/mlvalues.h>
#include <caml/signals.h>

#include <guestfs.h>

#include "guestfs_c.h"

/* Copy a hashtable of string pairs into an assoc-list.  We return
 * the list in reverse order, but hashtables aren't supposed to be
 * ordered anyway.
 */
static CAMLprim value
copy_table (char * const * argv)
{
  CAMLparam0 ();
  CAMLlocal5 (rv, pairv, kv, vv, cons);
  int i;

  rv = Val_int (0);
  for (i = 0; argv[i] != NULL; i += 2) {
    kv = caml_copy_string (argv[i]);
    vv = caml_copy_string (argv[i+1]);
    pairv = caml_alloc (2, 0);
    Store_field (pairv, 0, kv);
    Store_field (pairv, 1, vv);
    cons = caml_alloc (2, 0);
    Store_field (cons, 1, rv);
    rv = cons;
    Store_field (cons, 0, pairv);
  }

  CAMLreturn (rv);
}

static CAMLprim value
copy_lvm_pv (const struct guestfs_lvm_pv *pv)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);

  rv = caml_alloc (14, 0);
  v = caml_copy_string (pv->pv_name);
  Store_field (rv, 0, v);
  v = caml_alloc_string (32);
  memcpy (String_val (v), pv->pv_uuid, 32);
  Store_field (rv, 1, v);
  v = caml_copy_string (pv->pv_fmt);
  Store_field (rv, 2, v);
  v = caml_copy_int64 (pv->pv_size);
  Store_field (rv, 3, v);
  v = caml_copy_int64 (pv->dev_size);
  Store_field (rv, 4, v);
  v = caml_copy_int64 (pv->pv_free);
  Store_field (rv, 5, v);
  v = caml_copy_int64 (pv->pv_used);
  Store_field (rv, 6, v);
  v = caml_copy_string (pv->pv_attr);
  Store_field (rv, 7, v);
  v = caml_copy_int64 (pv->pv_pe_count);
  Store_field (rv, 8, v);
  v = caml_copy_int64 (pv->pv_pe_alloc_count);
  Store_field (rv, 9, v);
  v = caml_copy_string (pv->pv_tags);
  Store_field (rv, 10, v);
  v = caml_copy_int64 (pv->pe_start);
  Store_field (rv, 11, v);
  v = caml_copy_int64 (pv->pv_mda_count);
  Store_field (rv, 12, v);
  v = caml_copy_int64 (pv->pv_mda_free);
  Store_field (rv, 13, v);
  CAMLreturn (rv);
}

static CAMLprim value
copy_lvm_pv_list (const struct guestfs_lvm_pv_list *pvs)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);
  int i;

  if (pvs->len == 0)
    CAMLreturn (Atom (0));
  else {
    rv = caml_alloc (pvs->len, 0);
    for (i = 0; i < pvs->len; ++i) {
      v = copy_lvm_pv (&pvs->val[i]);
      caml_modify (&Field (rv, i), v);
    }
    CAMLreturn (rv);
  }
}

static CAMLprim value
copy_lvm_vg (const struct guestfs_lvm_vg *vg)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);

  rv = caml_alloc (19, 0);
  v = caml_copy_string (vg->vg_name);
  Store_field (rv, 0, v);
  v = caml_alloc_string (32);
  memcpy (String_val (v), vg->vg_uuid, 32);
  Store_field (rv, 1, v);
  v = caml_copy_string (vg->vg_fmt);
  Store_field (rv, 2, v);
  v = caml_copy_string (vg->vg_attr);
  Store_field (rv, 3, v);
  v = caml_copy_int64 (vg->vg_size);
  Store_field (rv, 4, v);
  v = caml_copy_int64 (vg->vg_free);
  Store_field (rv, 5, v);
  v = caml_copy_string (vg->vg_sysid);
  Store_field (rv, 6, v);
  v = caml_copy_int64 (vg->vg_extent_size);
  Store_field (rv, 7, v);
  v = caml_copy_int64 (vg->vg_extent_count);
  Store_field (rv, 8, v);
  v = caml_copy_int64 (vg->vg_free_count);
  Store_field (rv, 9, v);
  v = caml_copy_int64 (vg->max_lv);
  Store_field (rv, 10, v);
  v = caml_copy_int64 (vg->max_pv);
  Store_field (rv, 11, v);
  v = caml_copy_int64 (vg->pv_count);
  Store_field (rv, 12, v);
  v = caml_copy_int64 (vg->lv_count);
  Store_field (rv, 13, v);
  v = caml_copy_int64 (vg->snap_count);
  Store_field (rv, 14, v);
  v = caml_copy_int64 (vg->vg_seqno);
  Store_field (rv, 15, v);
  v = caml_copy_string (vg->vg_tags);
  Store_field (rv, 16, v);
  v = caml_copy_int64 (vg->vg_mda_count);
  Store_field (rv, 17, v);
  v = caml_copy_int64 (vg->vg_mda_free);
  Store_field (rv, 18, v);
  CAMLreturn (rv);
}

static CAMLprim value
copy_lvm_vg_list (const struct guestfs_lvm_vg_list *vgs)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);
  int i;

  if (vgs->len == 0)
    CAMLreturn (Atom (0));
  else {
    rv = caml_alloc (vgs->len, 0);
    for (i = 0; i < vgs->len; ++i) {
      v = copy_lvm_vg (&vgs->val[i]);
      caml_modify (&Field (rv, i), v);
    }
    CAMLreturn (rv);
  }
}

static CAMLprim value
copy_lvm_lv (const struct guestfs_lvm_lv *lv)
{
  CAMLparam0 ();
  CAMLlocal3 (rv, v, v2);

  rv = caml_alloc (16, 0);
  v = caml_copy_string (lv->lv_name);
  Store_field (rv, 0, v);
  v = caml_alloc_string (32);
  memcpy (String_val (v), lv->lv_uuid, 32);
  Store_field (rv, 1, v);
  v = caml_copy_string (lv->lv_attr);
  Store_field (rv, 2, v);
  v = caml_copy_int64 (lv->lv_major);
  Store_field (rv, 3, v);
  v = caml_copy_int64 (lv->lv_minor);
  Store_field (rv, 4, v);
  v = caml_copy_int64 (lv->lv_kernel_major);
  Store_field (rv, 5, v);
  v = caml_copy_int64 (lv->lv_kernel_minor);
  Store_field (rv, 6, v);
  v = caml_copy_int64 (lv->lv_size);
  Store_field (rv, 7, v);
  v = caml_copy_int64 (lv->seg_count);
  Store_field (rv, 8, v);
  v = caml_copy_string (lv->origin);
  Store_field (rv, 9, v);
  if (lv->snap_percent >= 0) { /* Some snap_percent */
    v2 = caml_copy_double (lv->snap_percent);
    v = caml_alloc (1, 0);
    Store_field (v, 0, v2);
  } else /* None */
    v = Val_int (0);
  Store_field (rv, 10, v);
  if (lv->copy_percent >= 0) { /* Some copy_percent */
    v2 = caml_copy_double (lv->copy_percent);
    v = caml_alloc (1, 0);
    Store_field (v, 0, v2);
  } else /* None */
    v = Val_int (0);
  Store_field (rv, 11, v);
  v = caml_copy_string (lv->move_pv);
  Store_field (rv, 12, v);
  v = caml_copy_string (lv->lv_tags);
  Store_field (rv, 13, v);
  v = caml_copy_string (lv->mirror_log);
  Store_field (rv, 14, v);
  v = caml_copy_string (lv->modules);
  Store_field (rv, 15, v);
  CAMLreturn (rv);
}

static CAMLprim value
copy_lvm_lv_list (const struct guestfs_lvm_lv_list *lvs)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);
  int i;

  if (lvs->len == 0)
    CAMLreturn (Atom (0));
  else {
    rv = caml_alloc (lvs->len, 0);
    for (i = 0; i < lvs->len; ++i) {
      v = copy_lvm_lv (&lvs->val[i]);
      caml_modify (&Field (rv, i), v);
    }
    CAMLreturn (rv);
  }
}

static CAMLprim value
copy_stat (const struct guestfs_stat *stat)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);

  rv = caml_alloc (13, 0);
  v = caml_copy_int64 (stat->dev);
  Store_field (rv, 0, v);
  v = caml_copy_int64 (stat->ino);
  Store_field (rv, 1, v);
  v = caml_copy_int64 (stat->mode);
  Store_field (rv, 2, v);
  v = caml_copy_int64 (stat->nlink);
  Store_field (rv, 3, v);
  v = caml_copy_int64 (stat->uid);
  Store_field (rv, 4, v);
  v = caml_copy_int64 (stat->gid);
  Store_field (rv, 5, v);
  v = caml_copy_int64 (stat->rdev);
  Store_field (rv, 6, v);
  v = caml_copy_int64 (stat->size);
  Store_field (rv, 7, v);
  v = caml_copy_int64 (stat->blksize);
  Store_field (rv, 8, v);
  v = caml_copy_int64 (stat->blocks);
  Store_field (rv, 9, v);
  v = caml_copy_int64 (stat->atime);
  Store_field (rv, 10, v);
  v = caml_copy_int64 (stat->mtime);
  Store_field (rv, 11, v);
  v = caml_copy_int64 (stat->ctime);
  Store_field (rv, 12, v);
  CAMLreturn (rv);
}

static CAMLprim value
copy_statvfs (const struct guestfs_statvfs *statvfs)
{
  CAMLparam0 ();
  CAMLlocal2 (rv, v);

  rv = caml_alloc (11, 0);
  v = caml_copy_int64 (statvfs->bsize);
  Store_field (rv, 0, v);
  v = caml_copy_int64 (statvfs->frsize);
  Store_field (rv, 1, v);
  v = caml_copy_int64 (statvfs->blocks);
  Store_field (rv, 2, v);
  v = caml_copy_int64 (statvfs->bfree);
  Store_field (rv, 3, v);
  v = caml_copy_int64 (statvfs->bavail);
  Store_field (rv, 4, v);
  v = caml_copy_int64 (statvfs->files);
  Store_field (rv, 5, v);
  v = caml_copy_int64 (statvfs->ffree);
  Store_field (rv, 6, v);
  v = caml_copy_int64 (statvfs->favail);
  Store_field (rv, 7, v);
  v = caml_copy_int64 (statvfs->fsid);
  Store_field (rv, 8, v);
  v = caml_copy_int64 (statvfs->flag);
  Store_field (rv, 9, v);
  v = caml_copy_int64 (statvfs->namemax);
  Store_field (rv, 10, v);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_launch (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("launch: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_launch (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "launch");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_wait_ready (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("wait_ready: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_wait_ready (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "wait_ready");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_kill_subprocess (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("kill_subprocess: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_kill_subprocess (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "kill_subprocess");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_add_drive (value gv, value filenamev)
{
  CAMLparam2 (gv, filenamev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("add_drive: used handle after closing it");

  const char *filename = String_val (filenamev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_add_drive (g, filename);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "add_drive");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_add_cdrom (value gv, value filenamev)
{
  CAMLparam2 (gv, filenamev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("add_cdrom: used handle after closing it");

  const char *filename = String_val (filenamev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_add_cdrom (g, filename);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "add_cdrom");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_config (value gv, value qemuparamv, value qemuvaluev)
{
  CAMLparam3 (gv, qemuparamv, qemuvaluev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("config: used handle after closing it");

  const char *qemuparam = String_val (qemuparamv);
  const char *qemuvalue =
    qemuvaluev != Val_int (0) ? String_val (Field (qemuvaluev, 0)) : NULL;
  int r;

  caml_enter_blocking_section ();
  r = guestfs_config (g, qemuparam, qemuvalue);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "config");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_qemu (value gv, value qemuv)
{
  CAMLparam2 (gv, qemuv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_qemu: used handle after closing it");

  const char *qemu = String_val (qemuv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_qemu (g, qemu);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_qemu");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_qemu (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_qemu: used handle after closing it");

  const char *r;

  caml_enter_blocking_section ();
  r = guestfs_get_qemu (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "get_qemu");

  rv = caml_copy_string (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_path (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_path: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_path (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_path");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_path (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_path: used handle after closing it");

  const char *r;

  caml_enter_blocking_section ();
  r = guestfs_get_path (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "get_path");

  rv = caml_copy_string (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_autosync (value gv, value autosyncv)
{
  CAMLparam2 (gv, autosyncv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_autosync: used handle after closing it");

  int autosync = Bool_val (autosyncv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_autosync (g, autosync);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_autosync");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_autosync (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_autosync: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_get_autosync (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "get_autosync");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_verbose (value gv, value verbosev)
{
  CAMLparam2 (gv, verbosev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_verbose: used handle after closing it");

  int verbose = Bool_val (verbosev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_verbose (g, verbose);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_verbose");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_verbose (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_verbose: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_get_verbose (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "get_verbose");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_ready (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_ready: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_ready (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_ready");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_config (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_config: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_config (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_config");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_launching (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_launching: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_launching (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_launching");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_busy (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_busy: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_busy (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_busy");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_state (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_state: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_get_state (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "get_state");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_busy (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_busy: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_busy (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_busy");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_ready (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_ready: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_ready (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_ready");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mount (value gv, value devicev, value mountpointv)
{
  CAMLparam3 (gv, devicev, mountpointv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mount: used handle after closing it");

  const char *device = String_val (devicev);
  const char *mountpoint = String_val (mountpointv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mount (g, device, mountpoint);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mount");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_sync (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("sync: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_sync (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "sync");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_touch (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("touch: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_touch (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "touch");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_cat (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("cat: used handle after closing it");

  const char *path = String_val (pathv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_cat (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "cat");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_ll (value gv, value directoryv)
{
  CAMLparam2 (gv, directoryv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("ll: used handle after closing it");

  const char *directory = String_val (directoryv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_ll (g, directory);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "ll");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_ls (value gv, value directoryv)
{
  CAMLparam2 (gv, directoryv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("ls: used handle after closing it");

  const char *directory = String_val (directoryv);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_ls (g, directory);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "ls");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_list_devices (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("list_devices: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_list_devices (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "list_devices");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_list_partitions (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("list_partitions: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_list_partitions (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "list_partitions");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_pvs (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("pvs: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_pvs (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "pvs");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_vgs (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("vgs: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_vgs (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "vgs");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lvs (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lvs: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_lvs (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "lvs");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_pvs_full (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("pvs_full: used handle after closing it");

  struct guestfs_lvm_pv_list *r;

  caml_enter_blocking_section ();
  r = guestfs_pvs_full (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "pvs_full");

  rv = copy_lvm_pv_list (r);
  guestfs_free_lvm_pv_list (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_vgs_full (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("vgs_full: used handle after closing it");

  struct guestfs_lvm_vg_list *r;

  caml_enter_blocking_section ();
  r = guestfs_vgs_full (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "vgs_full");

  rv = copy_lvm_vg_list (r);
  guestfs_free_lvm_vg_list (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lvs_full (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lvs_full: used handle after closing it");

  struct guestfs_lvm_lv_list *r;

  caml_enter_blocking_section ();
  r = guestfs_lvs_full (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "lvs_full");

  rv = copy_lvm_lv_list (r);
  guestfs_free_lvm_lv_list (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_read_lines (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("read_lines: used handle after closing it");

  const char *path = String_val (pathv);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_read_lines (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "read_lines");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_init (value gv, value rootv, value flagsv)
{
  CAMLparam3 (gv, rootv, flagsv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_init: used handle after closing it");

  const char *root = String_val (rootv);
  int flags = Int_val (flagsv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_init (g, root, flags);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_init");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_close (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_close: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_close (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_close");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_defvar (value gv, value namev, value exprv)
{
  CAMLparam3 (gv, namev, exprv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_defvar: used handle after closing it");

  const char *name = String_val (namev);
  const char *expr =
    exprv != Val_int (0) ? String_val (Field (exprv, 0)) : NULL;
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_defvar (g, name, expr);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_defvar");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_defnode (value gv, value namev, value exprv, value valv)
{
  CAMLparam4 (gv, namev, exprv, valv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_defnode: used handle after closing it");

  const char *name = String_val (namev);
  const char *expr = String_val (exprv);
  const char *val = String_val (valv);
  struct guestfs_int_bool *r;

  caml_enter_blocking_section ();
  r = guestfs_aug_defnode (g, name, expr, val);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "aug_defnode");

  rv = caml_alloc (2, 0);
  Store_field (rv, 0, Val_int (r->i));
  Store_field (rv, 1, Val_bool (r->b));
  guestfs_free_int_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_get (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_get: used handle after closing it");

  const char *path = String_val (pathv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_aug_get (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "aug_get");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_set (value gv, value pathv, value valv)
{
  CAMLparam3 (gv, pathv, valv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_set: used handle after closing it");

  const char *path = String_val (pathv);
  const char *val = String_val (valv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_set (g, path, val);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_set");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_insert (value gv, value pathv, value labelv, value beforev)
{
  CAMLparam4 (gv, pathv, labelv, beforev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_insert: used handle after closing it");

  const char *path = String_val (pathv);
  const char *label = String_val (labelv);
  int before = Bool_val (beforev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_insert (g, path, label, before);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_insert");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_rm (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_rm: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_rm (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_rm");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_mv (value gv, value srcv, value destv)
{
  CAMLparam3 (gv, srcv, destv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_mv: used handle after closing it");

  const char *src = String_val (srcv);
  const char *dest = String_val (destv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_mv (g, src, dest);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_mv");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_match (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_match: used handle after closing it");

  const char *path = String_val (pathv);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_aug_match (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "aug_match");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_save (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_save: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_save (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_save");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_load (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_load: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_aug_load (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "aug_load");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_aug_ls (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("aug_ls: used handle after closing it");

  const char *path = String_val (pathv);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_aug_ls (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "aug_ls");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_rm (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("rm: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_rm (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "rm");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_rmdir (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("rmdir: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_rmdir (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "rmdir");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_rm_rf (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("rm_rf: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_rm_rf (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "rm_rf");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mkdir (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mkdir: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mkdir (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mkdir");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mkdir_p (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mkdir_p: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mkdir_p (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mkdir_p");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_chmod (value gv, value modev, value pathv)
{
  CAMLparam3 (gv, modev, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("chmod: used handle after closing it");

  int mode = Int_val (modev);
  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_chmod (g, mode, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "chmod");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_chown (value gv, value ownerv, value groupv, value pathv)
{
  CAMLparam4 (gv, ownerv, groupv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("chown: used handle after closing it");

  int owner = Int_val (ownerv);
  int group = Int_val (groupv);
  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_chown (g, owner, group, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "chown");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_exists (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("exists: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_exists (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "exists");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_file (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_file: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_file (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_file");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_is_dir (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("is_dir: used handle after closing it");

  const char *path = String_val (pathv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_is_dir (g, path);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "is_dir");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_pvcreate (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("pvcreate: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_pvcreate (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "pvcreate");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_vgcreate (value gv, value volgroupv, value physvolsv)
{
  CAMLparam3 (gv, volgroupv, physvolsv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("vgcreate: used handle after closing it");

  const char *volgroup = String_val (volgroupv);
  char **physvols = ocaml_guestfs_strings_val (g, physvolsv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_vgcreate (g, volgroup, physvols);
  caml_leave_blocking_section ();
  ocaml_guestfs_free_strings (physvols);
  if (r == -1)
    ocaml_guestfs_raise_error (g, "vgcreate");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lvcreate (value gv, value logvolv, value volgroupv, value mbytesv)
{
  CAMLparam4 (gv, logvolv, volgroupv, mbytesv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lvcreate: used handle after closing it");

  const char *logvol = String_val (logvolv);
  const char *volgroup = String_val (volgroupv);
  int mbytes = Int_val (mbytesv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_lvcreate (g, logvol, volgroup, mbytes);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "lvcreate");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mkfs (value gv, value fstypev, value devicev)
{
  CAMLparam3 (gv, fstypev, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mkfs: used handle after closing it");

  const char *fstype = String_val (fstypev);
  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mkfs (g, fstype, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mkfs");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_sfdisk (value gv, value devicev, value cylsv, value headsv, value sectorsv, value linesv)
{
  CAMLparam5 (gv, devicev, cylsv, headsv, sectorsv);
  CAMLxparam1 (linesv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("sfdisk: used handle after closing it");

  const char *device = String_val (devicev);
  int cyls = Int_val (cylsv);
  int heads = Int_val (headsv);
  int sectors = Int_val (sectorsv);
  char **lines = ocaml_guestfs_strings_val (g, linesv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_sfdisk (g, device, cyls, heads, sectors, lines);
  caml_leave_blocking_section ();
  ocaml_guestfs_free_strings (lines);
  if (r == -1)
    ocaml_guestfs_raise_error (g, "sfdisk");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_sfdisk_byte (value *argv, int argn)
{
  return ocaml_guestfs_sfdisk (argv[0], argv[0], argv[1], argv[2], argv[3], argv[4]);
}

CAMLprim value
ocaml_guestfs_write_file (value gv, value pathv, value contentv, value sizev)
{
  CAMLparam4 (gv, pathv, contentv, sizev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("write_file: used handle after closing it");

  const char *path = String_val (pathv);
  const char *content = String_val (contentv);
  int size = Int_val (sizev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_write_file (g, path, content, size);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "write_file");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_umount (value gv, value pathordevicev)
{
  CAMLparam2 (gv, pathordevicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("umount: used handle after closing it");

  const char *pathordevice = String_val (pathordevicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_umount (g, pathordevice);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "umount");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mounts (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mounts: used handle after closing it");

  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_mounts (g);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "mounts");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_umount_all (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("umount_all: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_umount_all (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "umount_all");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lvm_remove_all (value gv)
{
  CAMLparam1 (gv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lvm_remove_all: used handle after closing it");

  int r;

  caml_enter_blocking_section ();
  r = guestfs_lvm_remove_all (g);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "lvm_remove_all");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_file (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("file: used handle after closing it");

  const char *path = String_val (pathv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_file (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "file");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_command (value gv, value argumentsv)
{
  CAMLparam2 (gv, argumentsv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("command: used handle after closing it");

  char **arguments = ocaml_guestfs_strings_val (g, argumentsv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_command (g, arguments);
  caml_leave_blocking_section ();
  ocaml_guestfs_free_strings (arguments);
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "command");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_command_lines (value gv, value argumentsv)
{
  CAMLparam2 (gv, argumentsv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("command_lines: used handle after closing it");

  char **arguments = ocaml_guestfs_strings_val (g, argumentsv);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_command_lines (g, arguments);
  caml_leave_blocking_section ();
  ocaml_guestfs_free_strings (arguments);
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "command_lines");

  rv = caml_copy_string_array ((const char **) r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_stat (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("stat: used handle after closing it");

  const char *path = String_val (pathv);
  struct guestfs_stat *r;

  caml_enter_blocking_section ();
  r = guestfs_stat (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "stat");

  rv = copy_stat (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lstat (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lstat: used handle after closing it");

  const char *path = String_val (pathv);
  struct guestfs_stat *r;

  caml_enter_blocking_section ();
  r = guestfs_lstat (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "lstat");

  rv = copy_stat (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_statvfs (value gv, value pathv)
{
  CAMLparam2 (gv, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("statvfs: used handle after closing it");

  const char *path = String_val (pathv);
  struct guestfs_statvfs *r;

  caml_enter_blocking_section ();
  r = guestfs_statvfs (g, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "statvfs");

  rv = copy_statvfs (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_tune2fs_l (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("tune2fs_l: used handle after closing it");

  const char *device = String_val (devicev);
  int i;
  char **r;

  caml_enter_blocking_section ();
  r = guestfs_tune2fs_l (g, device);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "tune2fs_l");

  rv = copy_table (r);
  for (i = 0; r[i] != NULL; ++i) free (r[i]);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_setro (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_setro: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_setro (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_setro");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_setrw (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_setrw: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_setrw (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_setrw");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_getro (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_getro: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_getro (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_getro");

  rv = Val_bool (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_getss (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_getss: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_getss (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_getss");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_getbsz (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_getbsz: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_getbsz (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_getbsz");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_setbsz (value gv, value devicev, value blocksizev)
{
  CAMLparam3 (gv, devicev, blocksizev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_setbsz: used handle after closing it");

  const char *device = String_val (devicev);
  int blocksize = Int_val (blocksizev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_setbsz (g, device, blocksize);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_setbsz");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_getsz (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_getsz: used handle after closing it");

  const char *device = String_val (devicev);
  int64_t r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_getsz (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_getsz");

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_getsize64 (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_getsize64: used handle after closing it");

  const char *device = String_val (devicev);
  int64_t r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_getsize64 (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_getsize64");

  rv = caml_copy_int64 (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_flushbufs (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_flushbufs: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_flushbufs (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_flushbufs");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_blockdev_rereadpt (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("blockdev_rereadpt: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_blockdev_rereadpt (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "blockdev_rereadpt");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_upload (value gv, value filenamev, value remotefilenamev)
{
  CAMLparam3 (gv, filenamev, remotefilenamev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("upload: used handle after closing it");

  const char *filename = String_val (filenamev);
  const char *remotefilename = String_val (remotefilenamev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_upload (g, filename, remotefilename);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "upload");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_download (value gv, value remotefilenamev, value filenamev)
{
  CAMLparam3 (gv, remotefilenamev, filenamev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("download: used handle after closing it");

  const char *remotefilename = String_val (remotefilenamev);
  const char *filename = String_val (filenamev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_download (g, remotefilename, filename);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "download");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_checksum (value gv, value csumtypev, value pathv)
{
  CAMLparam3 (gv, csumtypev, pathv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("checksum: used handle after closing it");

  const char *csumtype = String_val (csumtypev);
  const char *path = String_val (pathv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_checksum (g, csumtype, path);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "checksum");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_tar_in (value gv, value tarfilev, value directoryv)
{
  CAMLparam3 (gv, tarfilev, directoryv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("tar_in: used handle after closing it");

  const char *tarfile = String_val (tarfilev);
  const char *directory = String_val (directoryv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_tar_in (g, tarfile, directory);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "tar_in");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_tar_out (value gv, value directoryv, value tarfilev)
{
  CAMLparam3 (gv, directoryv, tarfilev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("tar_out: used handle after closing it");

  const char *directory = String_val (directoryv);
  const char *tarfile = String_val (tarfilev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_tar_out (g, directory, tarfile);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "tar_out");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_tgz_in (value gv, value tarballv, value directoryv)
{
  CAMLparam3 (gv, tarballv, directoryv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("tgz_in: used handle after closing it");

  const char *tarball = String_val (tarballv);
  const char *directory = String_val (directoryv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_tgz_in (g, tarball, directory);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "tgz_in");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_tgz_out (value gv, value directoryv, value tarballv)
{
  CAMLparam3 (gv, directoryv, tarballv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("tgz_out: used handle after closing it");

  const char *directory = String_val (directoryv);
  const char *tarball = String_val (tarballv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_tgz_out (g, directory, tarball);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "tgz_out");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mount_ro (value gv, value devicev, value mountpointv)
{
  CAMLparam3 (gv, devicev, mountpointv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mount_ro: used handle after closing it");

  const char *device = String_val (devicev);
  const char *mountpoint = String_val (mountpointv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mount_ro (g, device, mountpoint);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mount_ro");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mount_options (value gv, value optionsv, value devicev, value mountpointv)
{
  CAMLparam4 (gv, optionsv, devicev, mountpointv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mount_options: used handle after closing it");

  const char *options = String_val (optionsv);
  const char *device = String_val (devicev);
  const char *mountpoint = String_val (mountpointv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mount_options (g, options, device, mountpoint);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mount_options");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mount_vfs (value gv, value optionsv, value vfstypev, value devicev, value mountpointv)
{
  CAMLparam5 (gv, optionsv, vfstypev, devicev, mountpointv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mount_vfs: used handle after closing it");

  const char *options = String_val (optionsv);
  const char *vfstype = String_val (vfstypev);
  const char *device = String_val (devicev);
  const char *mountpoint = String_val (mountpointv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mount_vfs (g, options, vfstype, device, mountpoint);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mount_vfs");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_debug (value gv, value subcmdv, value extraargsv)
{
  CAMLparam3 (gv, subcmdv, extraargsv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("debug: used handle after closing it");

  const char *subcmd = String_val (subcmdv);
  char **extraargs = ocaml_guestfs_strings_val (g, extraargsv);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_debug (g, subcmd, extraargs);
  caml_leave_blocking_section ();
  ocaml_guestfs_free_strings (extraargs);
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "debug");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_lvremove (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("lvremove: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_lvremove (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "lvremove");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_vgremove (value gv, value vgnamev)
{
  CAMLparam2 (gv, vgnamev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("vgremove: used handle after closing it");

  const char *vgname = String_val (vgnamev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_vgremove (g, vgname);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "vgremove");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_pvremove (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("pvremove: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_pvremove (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "pvremove");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_e2label (value gv, value devicev, value labelv)
{
  CAMLparam3 (gv, devicev, labelv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_e2label: used handle after closing it");

  const char *device = String_val (devicev);
  const char *label = String_val (labelv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_e2label (g, device, label);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_e2label");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_e2label (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_e2label: used handle after closing it");

  const char *device = String_val (devicev);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_get_e2label (g, device);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "get_e2label");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_set_e2uuid (value gv, value devicev, value uuidv)
{
  CAMLparam3 (gv, devicev, uuidv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("set_e2uuid: used handle after closing it");

  const char *device = String_val (devicev);
  const char *uuid = String_val (uuidv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_set_e2uuid (g, device, uuid);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "set_e2uuid");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_get_e2uuid (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("get_e2uuid: used handle after closing it");

  const char *device = String_val (devicev);
  char *r;

  caml_enter_blocking_section ();
  r = guestfs_get_e2uuid (g, device);
  caml_leave_blocking_section ();
  if (r == NULL)
    ocaml_guestfs_raise_error (g, "get_e2uuid");

  rv = caml_copy_string (r);
  free (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_fsck (value gv, value fstypev, value devicev)
{
  CAMLparam3 (gv, fstypev, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("fsck: used handle after closing it");

  const char *fstype = String_val (fstypev);
  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_fsck (g, fstype, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "fsck");

  rv = Val_int (r);
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_zero (value gv, value devicev)
{
  CAMLparam2 (gv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("zero: used handle after closing it");

  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_zero (g, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "zero");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_grub_install (value gv, value rootv, value devicev)
{
  CAMLparam3 (gv, rootv, devicev);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("grub_install: used handle after closing it");

  const char *root = String_val (rootv);
  const char *device = String_val (devicev);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_grub_install (g, root, device);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "grub_install");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_cp (value gv, value srcv, value destv)
{
  CAMLparam3 (gv, srcv, destv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("cp: used handle after closing it");

  const char *src = String_val (srcv);
  const char *dest = String_val (destv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_cp (g, src, dest);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "cp");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_cp_a (value gv, value srcv, value destv)
{
  CAMLparam3 (gv, srcv, destv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("cp_a: used handle after closing it");

  const char *src = String_val (srcv);
  const char *dest = String_val (destv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_cp_a (g, src, dest);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "cp_a");

  rv = Val_unit;
  CAMLreturn (rv);
}

CAMLprim value
ocaml_guestfs_mv (value gv, value srcv, value destv)
{
  CAMLparam3 (gv, srcv, destv);
  CAMLlocal1 (rv);

  guestfs_h *g = Guestfs_val (gv);
  if (g == NULL)
    caml_failwith ("mv: used handle after closing it");

  const char *src = String_val (srcv);
  const char *dest = String_val (destv);
  int r;

  caml_enter_blocking_section ();
  r = guestfs_mv (g, src, dest);
  caml_leave_blocking_section ();
  if (r == -1)
    ocaml_guestfs_raise_error (g, "mv");

  rv = Val_unit;
  CAMLreturn (rv);
}

